require "sheltie_client/version"
require 'bunny'
require 'active_support/core_ext'

module SheltieClient
  class Client

    @@connection = nil

    def initialize(opts)
      @conn = Bunny.new(opts)
      @conn.start
      @conn
    end
    
    def self.publish(agent, metric, value, registered_at=Time.now.to_i)
      if SheltieClient::Client.connection
        SheltieClient::Client.connection.queue.publish({agent: agent, metric: metric, value: value, registered_at: registered_at}.to_json, :routing_key => SheltieClient::Client.connection.queue.name, :persistent => true)
        true
      else
        false
      end
    end

    def queue
      if !@q
        ch = @conn.create_channel
        @q  = ch.queue("sheltie.metrics", :durable => true)
        x  = ch.default_exchange
      end
      @q
    end

    def self.connection
      @@connection
    end

    def self.connect(opts)
      @@connection ||= SheltieClient::Client.new(opts)
      true
    end
  end
end


